package net.wanji.common.action;

import net.wanji.common.annotation.ActionBean;
import net.wanji.common.annotation.ActionMethod;
import net.wanji.common.annotation.ActionMethodParameter;
import org.apache.commons.lang3.StringUtils;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * <>
 *
 * @author wanji
 * 2020/6/11 17:42
 */
@ActionBean(name = "字符串")
public class StringAction {

    @ActionMethod(name = "去空格")
    @ActionMethodParameter(names = {"目标字符串"})
    public static String trim(String str) {
        return str == null ? str : str.trim();
    }

    @ActionMethod(name = "指定起始的字符串截取")
    @ActionMethodParameter(names = {"目标字符串", "开始位置", "结束位置"})
    public static String substring(String target, int start, int end) {
        return target == null ? null : target.substring(start, end);
    }

    @ActionMethod(name = "指定开始的字符串截取")
    @ActionMethodParameter(names = {"目标字符串", "开始位置"})
    public static String substringForStart(String target, int start) {
        return target == null ? null : target.substring(start);
    }

    @ActionMethod(name = "指定结束的字符串截取")
    @ActionMethodParameter(names = {"目标字符串", "结束位置"})
    public static String substringForEnd(String target, int end) {
        return target == null ? null : target.substring(0, end);
    }

    @ActionMethod(name = "转小写")
    @ActionMethodParameter(names = {"目标字符串"})
    public static String toLowerCase(String target) {
        return target == null ? null : target.toLowerCase();
    }

    @ActionMethod(name = "转大写")
    @ActionMethodParameter(names = {"目标字符串"})
    public static String toUpperCase(String target) {
        return target == null ? null : target.toUpperCase();
    }

    @ActionMethod(name = "获取长度")
    @ActionMethodParameter(names = {"目标字符串"})
    public static Integer length(String target) {
        return target == null ? null : target.length();
    }

    @ActionMethod(name = "获取字符")
    @ActionMethodParameter(names = {"目标字符串", "位置"})
    public static Character charAt(String target, int index) {
        return target == null ? null : target.charAt(index);
    }

    @ActionMethod(name = "字符首次出现位置")
    @ActionMethodParameter(names = {"目标字符串", "要查找的字符串"})
    public static Integer indexOf(String target, String str) {
        return target == null ? null : target.indexOf(str);
    }

    @ActionMethod(name = "字符最后出现位置")
    @ActionMethodParameter(names = {"目标字符串", "要查找的字符串"})
    public static Integer lastIndexOf(String target, String str) {
        return target == null ? null : target.lastIndexOf(str);
    }

    @ActionMethod(name = "替换字符串")
    @ActionMethodParameter(names = {"目标字符串", "原字符串", "新字符串"})
    public static String replace(String target, String oldStr, String newStr) {
        return target == null ? null : target.replace(oldStr, newStr);
    }

    @ActionMethod(name = "拆分字符串为集合")
    @ActionMethodParameter(names = {"目标字符串", "拆分的字符"})
    public static List<String> split(String target, String regex) {
        if (StringUtils.isBlank(target)) {
            return new ArrayList<>();
        } else {
            String[] split = target.split(regex);
            return Arrays.asList(split);
        }
    }
}
