package net.wanji.common.enums;

import java.util.Arrays;

/**
 * <>
 *
 * @author wanji
 * 2020/6/5 12:26
 */
public enum Datatype {

    /**
     * String
     */
    String,
    /**
     * integer
     */
    Integer,
    /**
     * char
     */
    Char,
    /**
     * double
     */
    Double,
    /**
     * long
     */
    Long,
    /**
     * float
     */
    Float,
    /**
     * bigdecimal
     */
    BigDecimal,
    /**
     * boolean
     */
    Boolean,
    /**
     * date
     */
    Date,
    /**
     * list
     */
    List,
    /**
     * set
     */
    Set,
    /**
     * map
     */
    Map,
    /**
     * enum
     */
    Enum,
    /**
     * object
     */
    Object;

    public static Datatype parse(String datatype){
        return Arrays.stream(values())
                .filter(v -> v.toString().equals(datatype))
                .findFirst()
                .orElse(null);
    }

}
