package net.wanji.common.enums;

/**
 * @author Kent HAN
 * @date 2022/10/27 10:10
 */
public enum EventAlarmEnum {
    ONE(1, "事故"),
    TWO(2, "拥堵"),
    THREE(3, "管制"),
    FOUR(4, "施工");

    private final int code;
    private final String msg;

    EventAlarmEnum(int code, String msg) {
        this.code = code;
        this.msg = msg;
    }

    public static String getMsgByCode(int code) {
        for (EventAlarmEnum value : EventAlarmEnum.values()) {
            if (value.code == code) {
                return value.msg;
            }
        }
        return null;
    }

    public String getMsg() {
        return msg;
    }
}
