package net.wanji.common.enums;

/**
 * @author Kent HAN
 * @date 2022/10/27 10:10
 */
public enum EventAlarmSourceEnum {
    ONE(1, "接处警"),
    TWO(2, "交管部门"),
    THREE(3, "互联网");

    private final int code;
    private final String msg;

    EventAlarmSourceEnum(int code, String msg) {
        this.code = code;
        this.msg = msg;
    }

    public static String getMsgByCode(int code) {
        for (EventAlarmSourceEnum value : EventAlarmSourceEnum.values()) {
            if (value.code == code) {
                return value.msg;
            }
        }
        return null;
    }

    public String getMsg() {
        return msg;
    }
}
