package net.wanji.common.framework;

import java.sql.Connection;
import java.util.ArrayList;
import java.util.List;

/**
 * EnvConstants.java
 *
 * @author wanji
 */
public final class Constants {
    /*记录当前用户*/
    public static ThreadLocal<String> current_user_id = ThreadLocal.withInitial(() -> "");
    //gisc-develop 工作流事务全局标识，默认不开启
    public static ThreadLocal<Boolean> OPEN_GLOBAL_TRANSACTION = ThreadLocal.withInitial(() -> Boolean.FALSE);
    //gisc-develop D2A事务实现，db操作临时conn存放
    public static ThreadLocal<List<Connection>> DB_CONNS = ThreadLocal.withInitial(ArrayList::new);
    //日志消息名称关键字
    public static final String BP_LOG = "log";
    //数据扩展表关键字
    public static final String TABLE_RELATION="_relation";

    public final class MessageES{
        public static final String MESSAGE_HISTORY = "message_history";
        public static final String MESSAGE_CONSUME_HISTORY = "message_consume_history";
        public static final String MESSAGE_FILTER_HISTORY = "message_filter_history";
    }

    public final class WebsocketMessage{
        public static final String NEW_UNREAD_MESSAGE = "";
        public static final String GET_UNREAD_COUNT="";
        public static final String GET_READ_MESSAGE="";
        public static final String GET_UNREAD_MESSAGE="";

    }

    public final class igniteCacheName {
        //bp design 模块缓存名称
        public static final String BP_DESIGN_CACHE = "gisc-portal-cache-name";

        public static final String BP_GATEWAY_CACHE = "gisc-gateway-cache-name";

        public static final String GATEWAY_CACHE = "gatewayCache";

        public static final String API_RESTFUL_CACHE = "apiRestfulCache";

        public static final String A2A_RESTFUL_CACHE = "a2aRestfulCache";

        public static final String D2A_TABLE_RESTFUL_CACHE = "d2aTableRestfulCache";

        public static final String BP_ROADNET_CACHE = "gisc-roadnet-cache-name";
    }

    public final class Env {

        public static final String BASE_HOME = "";

        public static final String WORKFLOW_HOME = "configs/workflow/";
    }

    // RepoModuleType 分类
    public final class RepoModuleTypeType {

        public static final String RULE = "rule";

        public static final String COMMON = "common";

        public static final String APPLICATION = "application";
    }

    public final class MqTopic {

        public static final String JAVA_MODULE_OFFLINE_TOPIC = "javaModuleOffline";

        public static final String JAVA_MODULE_ONLINE_TOPIC = "javaModuleOnline";
    }

    public final class MqKey {
    }

    public final class ImportExport {
        public static final String IMPORT = "import";

        public static final String EXPORT = "export";
    }

    public final class DevExport {
        public static final String MAN_DEV_APP = "MAN_DEV_APP.csv";

        public static final String MAN_DEV_APPTHEME = "MAN_DEV_APPTHEME.csv";

        public static final String MAN_APP_TYPE = "MAN_APP_TYPE.csv";

        public static final String MAN_GW_D2A_DATABASE = "MAN_GW_D2A_DATABASE.csv";

        public static final String MAN_DEV_API_RESTFUL = "MAN_DEV_API_RESTFUL.csv";

        public static final String MAN_GW_D2A_TABLE_RESTFUL = "MAN_GW_D2A_TABLE_RESTFUL.csv";

        public static final String MAN_DEV_RESTFUL = "MAN_DEV_RESTFUL.csv";

        public static final String MAN_GW_D2A_TABLE = "MAN_GW_D2A_TABLE.csv";

        public static final String MAN_GW_D2A_TABLE_FIELDS = "MAN_GW_D2A_TABLE_FIELDS.csv";

        public static final String MAN_DEV_DATA_DICT_CONTENT = "MAN_DEV_DATA_DICT_CONTENT.csv";

        public static final String MAN_DEV_DATA_DICT_TYPE = "MAN_DEV_DATA_DICT_TYPE.csv";

        public static final String MAN_GW_M2A_MAIL = "MAN_GW_M2A_MAIL.csv";

        public static final String MAN_REPO_MODULE_TYPE = "MAN_REPO_MODULE_TYPE.csv";

        public static final String MAN_REPO_MODULE = "MAN_REPO_MODULE.csv";

        public static final String MAN_DEV_MODULE = "MAN_DEV_MODULE.csv";

        public static final String MAN_MSG_TOPIC = "MAN_MSG_TOPIC.csv";

        public static final String MAN_MSG_ROUTE = "MAN_MSG_ROUTE.csv";

        public static final String MAN_MSG_SUBSCRIBE = "MAN_MSG_SUBSCRIBE.csv";

        public static final String MAN_MSG_FILTER_ITEM = "MAN_MSG_FILTER_ITEM.csv";

        public static final String CLI_IC_APP_BUSINESS_ACCOUNT = "CLI_IC_APP_BUSINESS_ACCOUNT.csv";

        public static final String CLI_IC_ORGANIZATION = "CLI_IC_ORGANIZATION.csv";

        public static final String CLI_IC_ROLE = "CLI_IC_ROLE.csv";

        public static final String CLI_IC_ROLE_BUSINESSACCOUNT_RLAT = "CLI_IC_ROLE_BUSINESSACCOUNT_RLAT.csv";

        public static final String CLI_DEV_MENU = "CLI_DEV_MENU.csv";
        public static final String MAN_MSG_TOPIC_FILTER_ITEM_RLAT= "MAN_MSG_TOPIC_FILTER_ITEM_RLAT.csv";
        public static final String MAN_DEV_PLUGIN_PARAM="MAN_DEV_PLUGIN_PARAM.csv";
    }

    public final class BpmExport {
        //导出流程定义表
        public static final String WORKFLOW = "MAN_BPM_WORKFLOW.csv";
        //导出流程实例表
        public static final String WORKFLOW_INST = "MAN_BPM_WORKFLOW_INST.csv";
        //导出流程任务表
        public static final String WORKFLOW_INST_TASK = "MAN_BPM_WORKFLOW_TASK.csv";
        //导出流程任务处理人表
        public static final String WORKFLOW_INST_TASK_PERSON = "MAN_BPM_WORKFLOW_TASK_PERSON.csv";
        //导出流程任务会签表
        public static final String WORKFLOW_INST_TASK_SIGN = "MAN_BPM_WORKFLOW_TASK_COUNTERSIGN.csv";
        //导出流程通知表
        public static final String WORKFLOW_NOTICE = "MAN_BPM_WORKFLOW_NOTICE.csv";
        //导出流程分类表
        public static final String WORKFLOW_TYPE = "MAN_BPM_WORKFLOW_TYPE.csv";
        //导出流程参数表
        public static final String WORKFLOW_BPM_VAR = "MAN_BPM_VAR.csv";
        //导出流程规则表
        public static final String WORKFLOW_BPM_RULE = "MAN_BPM_RULE.csv";
        //导出流程节点表
        public static final String WORKFLOW_BPM_PLUGIN_PARAM = "MAN_BPM_PLUGIN_PARAM.csv";
        //导出流程邮件日志表
        public static final String WORKFLOW_MAIL_LOG = "MAN_BPM_MAIL_LOG.csv";
        //导出流程原因表
        public static final String WORKFLOW_LEAVE_INFO = "MAN_BPM_LEAVE_INFO.csv";
        //导出流程form表单表
        public static final String WORKFLOW_BPM_FORM = "MAN_BPM_FORM.csv";

        //导出页面表
        public static final String PAGE_WEB = "CLI_DEV_WEB_PAGE.csv";
        //导出组件表
        public static final String COMPONENT = "CLI_DEV_COMPONENT.csv";
        //导出组件组表
        public static final String COMPONENT_GROUP = "CLI_DEV_COMPONENT_GROUP.csv";
        //导出组件版本表
        public static final String COMPONENT_VERSION = "CLI_DEV_COMPONENT_VERSION.csv";
    }
    /**
     * 系统基础服务路径
     */
    public final class RestPathPrefix {
        public static final String PREFIX = "bp/";
        public static final String DEVELOP_PREFIX = "develop/";
        public static final String LOG_PREFIX = "log/";
        public static final String DESIGN_PREFIX = "design/";
        public static final String MODEL_CONSOLE = "design/console/";
        public static final String MODEL_IDENTITYAUTH = "bp/auth/";
        public static final String MODEL_RESTFUL = "develop/restful/";
        public static final String MODEL_IDENTITY = "bp/identity/";
        public static final String MODEL_MSP = "bp/msp/";
        public static final String MODEL_DATAMANAGE = "design/datamanage/";
        public static final String MODEL_SGW = "design/sgw/";
        public static final String MODEL_DISPLAYCENTER = "design/displaycenter/";
        public static final String MODEL_TASKSCHEDULE = "design/taskschedule/";
        public static final String MODEL_WEB = "design/web/";
        public static final String FRONT_DEVELOP = "design/frontdevelop/";
        public static final String MODEL_BPM_MANAGER = "design/bpm/";
        public static final String MODEL_COMMON = "design/common/";
        public static final String MODEL_PROCESS_QUERY = "develop/processquery/";
        public static final String MODEL_MESSAGECENTER = "design/messagecenter/";
        public static final String MODEL_DEV = "design/develop/";
        public static final String MODEL_RULE = "design/rule/";
        public static final String MODEL_DATA_CHECK = "design/datacheck/";
        public static final String MODEL_TOOLS = "design/tools/";

        public static final String MODEL_CONFIG_CENTER = "design/configcenter/";
        public static final String MODEL_APPMANAGE = "design/appmanage/";
        public static final String MODEL_COMPONENT = "design/component/";
        public static final String MODEL_PORTAL = "design/portal/";
        public static final String MODEL_LOG = "log/logcenter/";
        public static final String MODEL_OPERATION_MONITOR = "design/operationmonitor/";
        public static final String MODEL_SYSTEM_SETTING = "design/systemsetting/";
        public static final String MODEL_STATISTICS = "bp/statistics/";
        public static final String MODEL_IM = "bp/im/";
        public static final String MODEL_DEVICE = "bp/things/";
        public static final String MODEL_IM_USER = "bp/user/";
        public static final String MODEL_IM_MESSAGE = "bp/message/";
        public static final String MODEL_IM_GROUP = "bp/group/";
        public static final String MODEL_IM_CHANNEL = "bp/channel/";
        public static final String MODEL_IM_ORGANIZATION = "bp/organization/";
        public static final String MODEL_IM_ORGAN_USER = "bp/organuser/";
        public static final String MODEL_IM_STATISTICS = "bp/statistics";
        public static final String MODEL_IM_TASK = "bp/task/";
        //数据源
        public static final String MODEL_DATASOURCE = "develop/datasource/";
        //数据资源
        public static final String MODEL_RESOURCE = "develop/resource/";
        //数据资源管理
        public static final String MODEL_RESOURCE_DATA = "develop/resourcedata/";
        //基础数据
        public static final String MODEL_BASE_DATA = "design/basedata/";
        //服务接口
        public static final String MODEL_DEV_SERVICE="develop/service/";
        //基础设置
        public static final String MODEL_CONFIG_DATA = "design/config/";
        //MSP
        public static final String MODEL_MSP_STYLECONFIG = "bp/msp/config/";
        //geoServer
        public static final String GEOSERVER = "geoserver/";

        /**
         * msp相关path定义
         */
        public static final String MODEL_MSP_SERVICE = "bp/msp/service/";
        public static final String MODEL_MSP_RESOURCE = "bp/msp/resource/";
        public static final String MODEL_MSP_CONFIG = "bp/msp/config/";
        public static final String MODEL_MSP_TOOL = "bp/msp/tool/";
        public static final String MODEL_MSP_SCENSE = "bp/msp/sense/";

        /***
         * 路网api定义
         */

        public static final String ROADNET_API = "api/roadnet/";
        /**
         * 设备信息
         */
        public static final String DEVICE_API = "api/device/";



    }

    public final class ServiceDevPathPrefix{
        /**
         * 数据库接口
         */
        public static final String DEV_DB_INTERFACE = "sgw/dbInterface";

        /**
         * 服务接口接口
         *
         */
        public static final String DEV_API_INTERFACE="sgw/apiInterface";

        /**
         * dev 注册服务
         */
        public static final String DEV_SGW_SERVICE = "develop/sgw/serviceInterface/";

        /**
         * vt 矢量栅格服务
         */
        public static final String DEV_VT_SERVICE="develop/vt/";

    }

    /**
     * 数据能力标签，元数据驱动的核心代码
     */
    public final class DataTag{

        /**
         * geometry
         * 空间表
         * --
         * export
         * 导出
         * --
         * nest
         * 套和
         * --
         * hook
         * 挂接
         * --
         * cache
         * 缓存
         * --
         * publish
         * 发布
         * --
         * edit
         */
        public static final String DATA_TAG_EXPORT="export";
        public static final String DATA_TAG_GEOMETRY="geometry";
        public static final String DATA_TAG_NEST="nest";
        public static final String DATA_TAG_HOOK="hook";
        public static final String DATA_TAG_CACHE="cache";
        public static final String DATA_TAG_PUBLISH="publish";
        public static final String DATA_TAG_EDIT="edit";
    }

    /**
     * Restful 对外的静态变量
     */
    public final class JsonView {

        public static final String STATUS_SUCCESS = "success";

        public static final String STATUS_FAIL = "fail";

        public static final String MESSAGE_FAIL = "操作失败";
        public static final String MESSAGE_SUCCESS = "操作成功";
        public static final String MESSAGE_PARAM_ERROR = "参数错误";
        public static final String MESSAGE_FROMAT_ERROR = "请求格式错误";
        public static final String MESSAGE_GET_PARAM_ERROR = "GET请求参数错误，注：暂不支持对象嵌套及数组";
        public static final String MESSAGE_LOGIN_SUCCESS = "登录成功";
        public static final String DELETE_ERROR_MSG = "表单【%s】已被流程【%s】使用";
    }

    /**
     * 接口服务参数
     */
    public static class ServiceConstants {
        public static final String API_URL = "url";
        public static final String API_ACCESS_METHOD = "method";
        public static final String API_ACCESS_GET = "get";
        public static final String API_ACCESS_POST = "post";
        public static final String API_ACCESS_PUT = "put";
        public static final String API_ACCESS_DELETE = "delete";
        public static final String API_BODY = "body";
        public static final String API_HEADER = "header";
        public static final String API_QUERY = "query";
        public static final String API_PATH = "pathParam";
    }

    /**
     * @Description: 网关表，类型相关参数
     * @return
     * @Author wanji
     * @Date 2020/2/14 10:10
     **/
    public static class ServiceType {
        public static final String SERVICE_D2A = "d2a";
        public static final String SERVICE_A2A = "a2a";
        public static final String SERVICE_WEB_SERVICE = "webservice";
        public static final String SERVICE_M2A = "m2a";
        public static final String SERVICE_ORCHESTRATION = "orchestration";
        public static final String SERVICE_DEVELOP = "develop";
        public static final String SERVICE_BASIC = "basic";
        public static final String SERVICE_BUSINESS = "business";
    }

    public static class AppType {
        public static final String APP_REPOSITORY = "repository";
        public static final String APP_EXTERNAL = "external";
        public static final String APP_ORCHESTRATION = "orchestration";
        public static final String APP_DEVELOP = "develop";
        public static final String APP_INTERNAL = "internal";
    }

    /*
     * apiType
     * api 类型
     */
    public static class RestfulApiType {
        //内部系统
        public static final String SERVICE_INSIDE = "inside";
        //外部系统
        public static final String SERVICE_OUTSIDE = "outside";
    }

    /*
     * apiParam
     * api 参数
     */
    public static class ApiParam {
        // mock
        public static final String MOCK = "mock";
        public static final String UNMOCK = "unmock";
    }

    /*
     * spring application name
     */
    public static class applicationName {
        public static final String BP_RESTFUL = "gisc-restful";
        public static final String BP_GATEWAY = "gisc-gateway";
        public static final String BP_DESIGN = "gisc-portal";
        public static final String BP_DEVELOP = "gisc-develop";
        public static final String BP_IDENTITY = "gisc-identity";
        public static final String BP_MSP = "gisc-msp";

    }

    /**
     * 缓存名称
     */
    public final class Cache {
        public static final String USER = "user";
        public static final String ONLINE_USER = "online_user";
        public static final String ONLINE_MOBILE_USER = "online_mobile_user";
        public static final String SYSTEM_SESSION = "system_session";
        public static final String LOGIN_CACHE = "login_cache";
        public static final String ETL_CACHE = "etl_workflow_cache";
        public static final String RE_CACHE = "re_workflow_cache";
        public static final String RE_CACHE_TOPIC = "re_workflow_cache_topic";
    }

    public final static class SystemParam {

        /**
         * 分隔符：下划线
         **/
        public static final String SEPARATOR_UNDER_LINE = "_";
        /**
         * 分隔符：减号
         **/
        public static final String SEPARATOR_MINUS = "-";
        /**
         * 逗号分隔符
         */
        public static String COMMA_SPLIT = ",";
        /**
         * 冒号分隔符
         */
        public static String COLON_SPLIT = ":";
        /**
         * 空Json串
         */
        public static String BLANK_JSON_STRING = "{}";

        /**
         * null
         */
        public static final String NULL = null;

        /**
         * 否
         */
        public static final Integer NO = 0;

        /**
         * 是
         */
        public static final Integer YES = 1;

        /**
         * 零
         */
        public static final Integer ZERO = 0;
    }

    /**
     * mysql 的字段类型
     */
    public final static class MysqlColumn {

        public final static String YEAR = "YEAR";
        public final static String DATE = "DATE";
        public final static String DATETIME = "DATETIME";
        public final static String TIMESTAMP = "TIMESTAMP";
        public final static String BINARY = "BINARY";
        public final static String VARBINARY = "VARBINARY";
        public final static String TINYINT = "TINYINT";
        public final static String SMALLINT = "SMALLINT";
        public final static String MEDIUMINT = "MEDIUMINT";
        public final static String INT = "INT";
        public final static String BIGINT = "BIGINT";
        public final static String BIT = "BIT";
        public final static String CHAR = "CHAR";
        public final static String VARCHAR = "VARCHAR";
        public final static String TEXT = "TEXT";
        public final static String LONGTEXT = "LONGTEXT";

        public final static String DECIMAL = "DECIMAL";
        public final static String DOUBLE = "DOUBLE";
        public final static String FLOAT = "FLOAT";
    }

    /**
     * postgresql 的字段类型
     */
    public final static class PostGreSqlColumn {
        public final static String TEXT = "text"; // string
        public final static String BPCHAR = "char"; // string
        public final static String VARCHAR = "varchar"; // string
        public final static String INT4 = "int4"; // integer
        public final static String INT2 = "int2"; // integer

        public final static String FLOAT4 = "float4"; // float
        public final static String FLOAT8 = "float8"; // double
        public final static String MONEY = "money"; // double

        public final static String BIT = "bit"; // boolean
        public final static String NUMERIC = "numeric"; // BigDecimal
        public final static String BOOL = "bool"; // boolean

        public final static String INT8 = "int8"; // long
        public final static String TIMESTAMP = "timestamp"; // timestamp
        public final static String TIME = "time"; // time
        public final static String DATE = "date"; // time
        public final static String BYTEA = "bytea"; // ?

        public final static String BOX = "box"; // object
        public final static String CIDR = "cidr"; // object
        public final static String INET = "inet"; // object
        public final static String MACADDR = "macaddr"; // object
        public final static String VARBIT = "varbit"; // object
        public final static String CIRCLE = "circle"; // object
        public final static String INTERVAL = "interval"; // object
        public final static String LINE = "line"; // object
        public final static String LSEG = "lseg"; // object
        public final static String POLYGON = "polygon"; // object
        public final static String POINT = "point"; // object
        public final static String PATH = "path"; // object
    }

    /**
     * oracle 的字段类型
     */
    public final static class OracleColumn {

        public final static String VARCHAR2 = "VARCHAR2";
        public final static String VARCHAR = "VARCHAR";
        public final static String ORACLE_CHAR = "CHAR";
        public final static String TIMESTAMP = "TIMESTAMP";
        public final static String DATE = "DATE";
        public final static String RAW = "RAW";
        public final static String NVARCHAR2 = "NVARCHAR2";
        public final static String TIMESTAMP_WITH_LOCAL_TIME_ZONE = "TIMESTAMP_WITH_LOCAL_TIME_ZONE";
        public final static String TIMESTAMP_WITH_TIME_ZONE = "TIMESTAMP_WITH_TIME_ZONE";

        public final static String INTERVAL_DAY_TO_SECOND = "INTERVAL_DAY_TO_SECOND";
        public final static String INTERVAL_YEAR_TO_MONTH = "INTERVAL_YEAR_TO_MONTH";
        public final static String NUMBER = "NUMBER";
        public final static String FLOAT = "FLOAT";
    }

    /**
     * @Description: sqlserver 的字段类型
     * @return
     * @Author wanji
     * @Date 2020/3/12 17:47
     **/
    public final static class SqlServerColumn {
        // Character 字符串
        public final static String CHAR = "char";
        public final static String VARCHAR = "varchar";
        public final static String TEXT = "text";
        // Number 类型
        public final static String TINYINT = "tinyint";
        public final static String SMALLINT = "smallint";
        public final static String INT = "int";
        public final static String BIGINT = "bigint";
        public final static String FLOAT = "float";
        // Binary类型
        public final static String BIT = "bit";
        public final static String BINARY = "binary";
        public final static String VARBINARY = "varbinary";
        // Date 类型
        public final static String DATETIME = "datetime";
        public final static String DATETIME2 = "datetime2";
        public final static String TIMESTAMP = "timestamp";
    }

    /**
     * 数据表相关
     */
    public final static class TableInfo {

        public static final String COLUMN_NAME = "COLUMN_NAME";
        public static final String TYPE_NAME = "TYPE_NAME";
        public static final String COLUMN_SIZE = "COLUMN_SIZE";
        public static final String IS_PK = "IS_PK";
        public static final String ISNULL = "ISNULL";
        public static final String IS_BUSINESS_PK = "IS_BUSINESS_PK";
        public static final String NULLABLE = "NULLABLE";
        public static final String COLUMN_DEF = "COLUMN_DEF";
        public static final String DECIMAL_DIGITS = "DECIMAL_DIGITS";
    }

    /**
     * 数据库
     */
    public final static class DataBase {
        public static final String MYSQL = "mysql";
        public static final String ORACLE = "oracle";
        public static final String BEYONDB = "beyondb";
        public static final String POSTGRESQL = "postgresql";
        public static final String SQLSERVER="sqlserver";
    }

    /**
     * 数据源的驱动
     */
    public static final class DbDriver {
        public static final String MYSQL = "com.mysql.jdbc.Driver";
        public static final String ORACLE = "oracle.jdbc.driver.OracleDriver";
        public static final String BEYONDB = "org.postgresql.Driver";
        public static final String IMPALA = "com.cloudera.impala.jdbc41.Driver";
        public static final String SQLSERVER = "com.microsoft.sqlserver.jdbc.SQLServerDriver";
        public static final String POSTGRESQL = "org.postgresql.Driver";
    }

    private static final String DATE_FORMAT_DAY = "yyyy-MM-dd";
    private static final String DATE_FORMAT_HOUR = "yyyy-MM-dd HH";
    private static final String DATE_FORMAT_MINUTE = "yyyy-MM-dd HH:mm";
    private static final String DATE_FORMAT_SECOND = "yyyy-MM-dd HH:mm:ss";
    private static final String DATE_FORMAT_MILLIS = "yyyy-MM-dd HH:mm:ss.SSS";
    private static final String DATE_FORMAT_TIME = "HH:mm:ss";
    private static final String DATE_FORMAT_WEEKDAY = "EEEE";

    public enum DATE_FORMAT {
        // 平台指定的时间格式字符串
        E_DATE_FORMAT_DAY(DATE_FORMAT_DAY),
        E_DATE_FORMAT_HOUR(DATE_FORMAT_HOUR),
        E_DATE_FORMAT_MINUTE(DATE_FORMAT_MINUTE),
        E_DATE_FORMAT_SECOND(DATE_FORMAT_SECOND),
        E_DATE_FORMAT_MILLIS(DATE_FORMAT_MILLIS),
        E_DATE_FORMAT_TIME(DATE_FORMAT_TIME),
        E_DATE_FORMAT_WEEKDAY(DATE_FORMAT_WEEKDAY);

        private final String strFormat;

        DATE_FORMAT(String strFormat) {
            this.strFormat = strFormat;
        }

        public String getStrFormat() {
            return strFormat;
        }
    }

    public static final class ServicePluginParamArea {
        public static final String GLOBAL = "global";
        public static final String PARAM = "param";
        public static final String OUTPUT = "output";
    }

    /*流程服务封装公用变量定义*/
    public final class ProcessService {
        public static final String ERROR_PARAM = "参数错误";
        public static final String NO_PROCESS_OPERATE = "参数错误，无对应流程操作";
        public static final String OPERATE_FAILD = "操作失败";
        public static final String DEPLOY_SUCCESS = "部署成功";
        public static final String DEPLOY_FAILD = "部署失败";
        public static final String UNDEPLOY_SUCCESS = "取消部署成功";
        public static final String UNDEPLOY_FAILD = "取消部署失败";
        public static final String SUCCEED_COUNT = "成功条数";
        public static final String FAILED_COUNT = "失败条数";
        public static final String FAILED_USER_ID = "失败用户id";
        public static final String START_ROWNUM = "startRowNum";
        public static final String PAGE_SIZE = "pageSize";
        public static final String PARAM_ERROR = "参数错误: processId=%s, userId=%s";
        public static final String NODE_CONFIG_ERROR = "节点配置错误";
        public static final String CANNOT_DEAL = "无法处理此任务，用户无对应操作权限或流程被暂停";
        public static final String COMMENT_TYPE_PASS = "PASS";
        public static final String COMMENT_TYPE_NO_PASS = "NO_PASS";
        public static final String NR_OF_INSTANCES_VAR_NAME = "nrOfInstances";
        public static final String NR_OF_ACTIVE_INSTANCES_VAR_NAME = "nrOfActiveInstances";
        public static final String APPROVED_COUNTER_VAR_NAME = "approvedCounter";
        public static final String COMMENT_BACK = "驳回";
        public static final String COMMENT_TYPE_BACK = "BACK";
        public static final String PAUSE_PROCESS = "流程已暂停，无法操作";
        public static final String ADMIN_ID = "admin";
        public static final String ALREADY_ACTIVE = "流程已激活，请勿重复操作";
        public static final String ALREADY_ASSIGNED = "任务已分配到指定用户，无需重复操作";
        public static final String COMMENT_ASSIGNE = "委派处理";
        public static final String REJECT_ASSIGNE = "驳回处理";
        public static final String COMMENT_TYPE_DEFAULT = "comment";
        public static final String PROCESS_START_EVENT = "start";
        public static final String PROCESS_END_EVENT = "end";
        public static final String START_USER_ID = "startUserId";
        public static final String PROCESS_INSTANCE_NAME = "processInstanceName";
        public static final String NEED_EMAIL_VAR_NAME = "needEmail";
        public static final String EMAIL_SERVICE_BEAN_NAME = "emailService";
        public static final String CANDIDATE_USERS_VAR_NAME = "candidateUsers";
        public static final String NOTICE_TYPE_START = "start";
        public static final String NOTICE_TYPE_NEXT = "next";
        /*流程表单保存在流程变量中的名称*/
        public static final String FORM_DATA_USER_DEFINED_VAR_NAME = "formDataUserDefined";
        public static final String START_FORM_DATA_USER_DEFINED_VAR_NAME = "startFormDataUserDefined";
        /*流程是否通过流程变量*/
        public static final String IS_APPROVED_VAR_NAME = "isApproved";
    }

    /*流程操作，枚举常量*/
    public enum ProcessOperateType {
        /*启动流程*/
        start,
        //审批，通过-不通过，通过变量控制
        approve,
        //驳回，到指定节点
        back,
        //委派
        transfer,
        //暂停
        suspend,
        //激活
        active,
        //作废
        delete,
        //抄送标记为已读
        readCopyTo,
        //抄送标记为未读
        unReadCopyTo;
    }

    /*流程节点权限计算，枚举常量*/
    public enum AUTH_CALCULATE_TYPE {
        //根据指定企业
        withCompany,
        //根据指定部门
        withDepartment,
        //根据岗位
        withStation,
        //根据角色
        withRole,
        //根据企业用户
        withCompanyUser,
        //求并集
        withUnion,
        //求交集
        withIntersection;
    }

    /**
     * 流程定义bpmn20.xml生成字符属性
     */
    public final static class Process {
        public static final String DEFAULT_CHARSET = "UTF-8"; //编码格式utf-8定义
        public static final String BPMN_XML_SUFFIX = ".bpmn20.xml"; //编码格式utf-8定义

        /*bpmn20.xml节点定义 start*/
        public static final String BPMN_DEFINITIONS = "definitions";
        public static final String BPMN_XMLNS = "xmlns";
        public static final String BPMN_XMLNS_CONTENT = "http://www.omg.org/spec/BPMN/20100524/MODEL";
        public static final String BPMN_XMLNS_ACTIVITI = "xmlns:activiti";
        public static final String BPMN_XMLNS_ACTIVITI_CONTENT = "http://activiti.org/bpmn";
        public static final String BPMN_TARGET_NAMESPACE = "targetNamespace";
        public static final String BPMN_TARGET_NAMESPACE_CONTENT = "http://activiti.org/bpmn20";
        public static final String BPMN_XMLNS_XSI = "xmlns:xsi";
        public static final String BPMN_XMLNS_XSI_CONTENT = "http://www.w3.org/2001/XMLSchema-instance";
        public static final String BPMN_PROCESS = "process";
        public static final String BPMN_ID = "id";
        public static final String BPMN_PROCESS_ID = "processId";
        public static final String BPMN_NAME = "name";
        public static final String BPMN_SOURCE_REF = "sourceRef";
        public static final String BPMN_TARGET_REF = "targetRef";
        public static final String BPMN_CALLED_ELEMENT = "calledElement";
        public static final String BPMN_EXTENSION_ELEMENTS = "extensionElements";
        public static final String BPMN_SOURCE = "source";
        public static final String BPMN_TARGET = "target";
        public static final String BPMN_ACTIVITI_IN = "activiti:in";
        public static final String BPMN_ACTIVITI_OUT = "activiti:out";
        public static final String BPMN_CONDITION_EXPRESSION = "conditionExpression";
        public static final String BPMN_XSI_TYPE = "xsi:type";
        public static final String BPMN_FORMAL_EXPRESSION = "tFormalExpression";
        public static final String BPMN_ACTIVITI_TASKLISTENER = "activiti:taskListener";
        public static final String BPMN_EVENT = "event";
        public static final String BPMN_CREATE = "create";
        public static final String BPMN_CLASS = "class";
        public static final String BPMN_ACTIVITI_CLASS = "activiti:class";
        public static final String BPMN_ACTIVITI_EXECUTION_LISTENER = "activiti:executionListener";
        public static final String BPMN_START = "start";
        public static final String BPMN_END = "end";
        public static final String BPMN_COMPLETE = "complete";
        public static final String BPMN_EXPRESSION = "expression";
        public static final String BPMN_COMPLETE_EXPRESSION_METHOD = "${userTaskHandler.postComplete(execution)}";
        public static final String BPMN_START_EXPRESSION_METHOD = "${userTaskHandler.preStart(execution)}";
        public static final String BPMN_ACTIVITI_CANDIDATE_USERS = "activiti:candidateUsers";
        public static final String BPMN_ACTIVITI_CANDIDATE_USERS_VALUE = "${candidates}";
        public static final String BPMN_MULTI_INSTANCE_LOOP_CHARACTERISTICS = "multiInstanceLoopCharacteristics";
        public static final String BPMN_IS_SEQUENTIAL = "isSequential";
        public static final String BPMN_IS_SEQUENTIAL_VALUE = "false";
        public static final String BPMN_ACTIVITI_COLLECTION = "activiti:collection";
        public static final String BPMN_ACTIVITI_COLLECTION_METHOD_NAME = "${userTaskHandler.getActorUser(execution)}";
        public static final String BPMN_ACTIVITI_ELEMENT_VARIABLE = "activiti:elementVariable";
        public static final String BPMN_CANDIDATES = "candidates";
        public static final String BPMN_COMPLETION_CONDITION = "completionCondition";
        public static final String BPMN_COMPLETION_CONDITION_CONTENT = "${userTaskHandler.dealComplete(execution)}";
        public static final String BPMN_PROCESS_EXECUTION_LISTENER_NAME = "net.wanji.design.engine.operate.impl.ProcessExecutionListener";
        public static final String BPMN_ACTIVITI_CLASS_NAME = "net.wanji.design.engine.operate.impl.AutoNodeServiceTask";


        /*bpmn20.xml节点定义 end*/

        /*流程设计器元素类型常量定义 start*/
        public static final String START_NODE = "startNode";
        public static final String END_NODE = "endNode";
        public static final String APPROVAL_NODE = "approvalNode";
        public static final String CONDITION_LINE = "conditionLine";
        public static final String FORK_NODE = "forkNode";
        public static final String CALL_ACTIVITY_NODE = "callActivityNode";
        public static final String AUTO_NODE = "autoNode";
        /*流程设计器元素类型常量定义 end*/

        /*xml创建节点类型，枚举常量*/
        public enum NodeType {
            START("startEvent"),
            END("endEvent"),
            USERTASK("userTask"),
            CONDITION("inclusiveGateway"),
            FLOW("sequenceFlow"),
            AUTO_NODE("serviceTask"),
            CALL_ACTIVITY("callActivity");

            private String value;

            NodeType(String value) {
                this.value = value;
            }

            @Override
            public String toString() {
                return this.value;
            }
        }

        /*审批节点类型*/
        public enum ApprovalNodeType {
            SINGLE_INSTANCE, //非会签节点
            MULTI_INSTANCE, //会签节点
            COPY_TO; //抄送节点, 通过任务接收人实现, 用权限控制
        }
    }

    /* 消息类型  */
    public enum MessageType {
        // 工作流消息
        BPM_MESSAGE_LOG("bpm_log");

        private String value;

        MessageType(String value) {
            this.value = value;
        }

        public static MessageType getEnumByValue(String value) {
            for (MessageType msgType : MessageType.values()) {
                if (msgType.toString().equals(value)) {
                    return msgType;
                }
            }
            return null;
        }

        @Override
        public String toString() {
            return this.value;
        }
    }

    /*日志保存操作类型*/
    public enum LogType {
        //接口日志 D2A
        D2A_INTERFACE_API_LOG("d2a_interface_api_log"),
        //接口日志 A2A
        A2A_INTERFACE_API_LOG("a2a_interface_api_log"),
        //接口日志 webservice
        WEBSERVICE_INTERFACE_API_LOG("webservice_interface_api_log"),
        //接口日志 基础接口
        BASE_INTERFACE_API_LOG("base_interface_api_log"),
        //接口日志 业务接口
        BUSINESS_INTERFACE_API_LOG("business_interface_api_log"),
        //接口日志 集成接口
        INTEGRATION_INTERFACE_API_LOG("integration_interface_api_log"),
        //接口日志 服务编排接口
        SGW_INTERFACE_API_LOG("sgw_interface_api_log"),
        //接口日志 邮件接口
        MAIL_INTERFACE_API_LOG("mail_interface_api_log"),
        //调度日志 d2a接口
        SCHEDULE_D2A_INTERFACE_API_LOG("schedule_d2a_interface_api_log"),
        //调度日志 A2A接口
        SCHEDULE_A2A_INTERFACE_API_LOG("schedule_a2a_interface_api_log"),
        //调度日志 基础接口
        MICROSERVICE_BASE_INTERFACE_API_LOG("microservice_base_interface_api_log"),
        //调度日志 业务接口
        MICROSERVICE_BUSINESS_INTERFACE_API_LOG("microservice_business_interface_api_log"),
        //调度日志 集成接口
        MICROSERVICE_INTEGRATION_INTERFACE_API_LOG("microservice_integration_interface_api_log"),
        //调度日志 服务编排
        MICROSERVICE_ORCHESTRATION_INTERFACE_API_LOG("microservice_orchestration_interface_api_log"),
        //调度日志 系统日志
        SYSTEM_TASK_LOG("system_task_log"),
        // 授权日志
        AUTH_LOG("auth_log"),
        //网关日志 基础接口日志
        GATEWAY_BASE_INTERFACE_API_LOG("gateway_base_interface_api_log"),
        //网关日志 业务接口日志
        GATEWAY_BUSINESS_INTERFACE_API_LOG("gateway_business_interface_api_log"),
        //网关日志 集成接口日志
        GATEWAY_INTEGRATION_INTERFACE_API_LOG("gateway_integration_interface_api_log"),
        //网关日志 a2a
        GATEWAY_A2A_INTERFACE_API_LOG("gateway_a2a_interface_api_log"),
        //网关日志 d2a
        GATEWAY_D2A_INTERFACE_API_LOG("gateway_d2a_interface_api_log"),
        //网关日志 服务编排
        GATEWAY_ORCHESTRATION_INTERFACE_API_LOG("gateway_orchestration_interface_api_log"),

        //服务开发插件日志
        DEV_SERVICE_PLUGIN_LOG("dev_service_plugin_log"),
        //服务开发流程日志
        DEV_SERVICE_FLOW_LOG("dev_service_flow_log"),
        //服务编排任务调度日志
        DEV_SCHEDULE_LOG("dev_schedule_log"),
        //服务编排发布日志
        SGW_SERVICE_PUBLISH_LOG("sgw_service_publish_log"),
        //服务编排插件日志
        SGW_SERVICE_PLUGIN_LOG("sgw_service_plugin_log"),
        //服务编排流程日志
        SGW_SERVICE_FLOW_LOG("sgw_service_flow_log"),
        //服务网关D2A日志
        SGW_D2A_SERVICE_LOG("sgw_d2a_service_log"),
        // 操作日志
        OPERATION_LOG("operation_log"),
        // 登录日志
        LOGIN_LOG("login_log");


        private String value;

        LogType(String value) {
            this.value = value;
        }

        public static LogType getEnumByValue(String value) {
            for (LogType logType : LogType.values()) {
                if (logType.toString().equals(value)) {
                    return logType;
                }
            }
            return null;
        }

        @Override
        public String toString() {
            return this.value;
        }
    }

    /**
     * 重构移植 重新划分模块后，把之前bp-domain下的constants移植过来 start 20200514
     */
    public static class ConsoleConstants {
        public static final class User {
            public static final String USER = "user";
            public static final String SYS_USER = "sysUser";
            public static final String TOKEN = "token";
        }
    }

    public static class FunctionManageConstants {
        public static final class FunctionJar {
            public static final String DOWNLOAD_PATH_KEY = "folder";
        }
    }

    public static class ServiceDevelopConstants {
        public static final class TableOperationLogConst {
            public static final String RES_TYPE = "table";
            // 业务表的操作类型。
            public static final String CREATE_TABLE_OPERATION = "new";
            public static final String DELETE_TABLE_OPERATION = "delete";
            public static final String UPDATE_TABLE_OPERATION = "update";
            public static final String IMPORT_TABLE_OPERATION = "import";
        }
    }

    public static class ServiceGateWayConstants {
        public static final class D2ADataBase {
            public static final String DB_MYSQL = "mysql";
            public static final String DB_ORACLE = "oracle";
            public static final String DB_SQLSERVER = "sqlserver";
            public static final String DB_BEYONDB = "beyondb";
            public static final String DB_POSTGRESQL = "postgresql";
        }

        public static final class DataSource {
            public static final String DB_ELASTICSEARCH = "elasticsearch";
            public static final String DB_KAFKA = "kafka";
            public static final String DB_RABBITMQ = "rabbitmq";
            public static final String DB_REDIS = "redis";
            public static final String DB_WEBSOCKET = "websocket";
            public static final String DB_WEBSERVICE = "webservice";
            public static final String DB_MONGODB="mongo";
        }

        public static final class TableRestfulConstants {
            public final static String INTERFACE_CODE_BY_PAGE = "findByPage";
            public final static String INTERFACE_CODE_BY_CONDITION = "findByWhere";
            public final static String INTERFACE_CODE_BY_ID = "findById";
            public final static String INTERFACE_CODE_INSERT = "insert";
            public final static String INTERFACE_CODE_UPDATE = "update";
            public final static String INTERFACE_CODE_DELETE = "delete";
            public final static String INTERFACE_CODE_BY_SQL = "multiTable";//bySql
        }
    }

    public static class ServicePublishConstants {
        public final class SqlConstants {
            public static final String BLANK = " ";
            public static final String FIELD_NAME_EN = "fieldNameEn";
            public static final String FIELD_TYPE = "type";
            public static final String FIELD_VALUE = "value";
            public static final String FIELD_FLAG = "flag";
            public static final String OPERATIONS = "operations";
            public static final String CONDITION_COLUMNS = "condition_columns";
            public static final String TYPES_AND_VALUES = "typesAndValues";
            public static final String CONDITION = "condition";
            public static final String SET = "set";
            public static final String OPERATION = "operation";
            public static final String BETWEEN_OPERATION = "between";
            public static final String PAGE_SIZE = "pageSize";
            public static final String PAGE_NUM = "pageNum";
            public static final String ORDER="order";
            public static final String IN_OPERATION="in";
            public static final String DESC_OPERATION="DESC";
            public static final String ASC_OPERATION="ASC";
            public static final String LIKE_OPERATION="like";

        }

        /**
         * 数据库类型常量定义
         */
        public final class DBType {
            public final static String MYSQL = "mysql";
            public final static String ORACLE = "oracle";
            public final static String SQLSERVER = "sqlserver";
            public final static String BEYONDB = "beyondb";
        }
    }

    public static class TaskScheduleConstants {
        public static class ScheduleStatus {
            public static final String STOP = "0";
            public static final String START = "1";
        }
    }

    public static class StatisticalConstants {
        public static class UserTrends {
            public static final String LOGIN_TIME = "loginTime";
            public static final String START_DATE = "startDate";
            public static final String END_DATE = "endDate";
            public static final String CHART_DATA = "chartData";
            public static final String DAILY_ACTIVE_USER = "dailyActiveUser";
            public static final String DAILY_NEW_USER = "dailyNewUser";
            public static final String DAILY_OLD_USER = "dailyOldUser";
            public static final String DAILY_USER_VISITS = "dailyUserVisits";
            public static final String DEDICATED_HOSTING_IP = "dedicatedHostingIp";

            public static final String DAILY_UPDATE_USER = "dailyUpdateUser";
            public static final String DAILY_NEWANDUPDATE_USER = "dailyNewAndUpdateUser";
            public static final String DAILY_STARTUP = "dailyStartup";
        }
    }

    /**
     * IM类型
     */
    public final class IM {
        public static final String IM_CLIENT_ID = "IMClientId";
        public static final String IM_PLATFORM = "IMPlatform";
        public static final String IM_USER = "IMUser";
        public static final String IM_TOKEN = "IMToken";
    }

    public final class Idnetity {
        public static final String UNI_USER_AGENT = "X-Uni-User-Agent";
    }

    /**重构移植 end  20200514*/


    /**
     * 空间数据表
     */
    public final class tableNameConstants {
        public static final String RID_RID = "rid_rid";
        public static final String RID_CROSS = "rid_cross";
        public static final String RID_LANE_OBJ = "rid_lane_obj";
        public static final String RID_AXF_THREE = "rid_axf_three";
        public static final String ROAD_SEGMENT = "data_roadsegment";
    }


    /**
     *  路网数据更新状态
     */
    public final class DataConstants {
        // 数据状态 0继承，1删除，2增加，3修改
        public final static String DATA_MODE_EXTENTD = "0";
        public final static String DATA_MODE_DELETE = "1";
        public final static String DATA_MODE_ADD = "2";
        public final static String DATA_MODE_EDIT = "3";

    }


}
