package net.wanji.common.framework.db;

import net.wanji.common.framework.Constants;
import net.wanji.common.framework.domain.Db;
import net.wanji.common.framework.exception.NodeException;
import net.wanji.common.framework.rest.Page;

import java.util.List;
import java.util.Map;

import static net.wanji.common.framework.Constants.ServicePublishConstants.SqlConstants.*;
import static net.wanji.common.framework.Constants.ServicePublishConstants.SqlConstants.BETWEEN_OPERATION;
import static net.wanji.common.framework.Constants.ServicePublishConstants.SqlConstants.IN_OPERATION;

/**
 * Sql拼接：复杂的使用已经封装好的MySQL、Oracle sql构造器即可。
 * <p>
 * Sql参数：拼接sql时用？做占位符，将处理好的占位符实际值，按照顺序，依据类型转化为java包装类对象，存入Object[] 中即可。
 * <p>
 * 执行Sql：使用apache common的 DbUtils工具类进行操作。
 *
 * @Author wanji
 * @Date 2020/3/11 16:10
 */
public interface DbInterface {

    String getDriver();

    String getDBUrl(Db dataBase);

    String getFindByPageSQL(String tableName, Page page,
                                               List<Map<String, Object>> whereParams,
                                               int startRowNum,
                                               List<Map<String, String>> orderMap);

    String getFindPageBySqlSQL(Page page,
                                                  int startRowNum,
                                                  String sql);

    String getFindByWhereSQL(String tableName, List<Map<String, Object>> whereParams, List<Map<String, String>> orderMap);

    String getFindCountSQL(String tableName, List<Map<String, Object>> whereParams);

    String getFindCountBySqlSQL(String sql);

    String getFindByIdSQL(String tableName, String id);

    String getDeleteSQL(String tableName, List<Map<String, Object>> whereParams);

    String getInsertSQL(String tableName, List<Map<String, Object>> insertParams);

    String getUpdateSQL(String tableName, List<Map<String, Object>> updateParams,
                                           List<Map<String, Object>> whereParams);

    Object typeHandler(String fieldType, String fieldValue) throws NodeException;
    //Object[] typeHandler(List<Map<String, Object>> paramList);
    // throws NodeException {
      /*  List<Object> list = new ArrayList<>();
        for (Map<String, Object> paramMap : paramList) {
            String fieldType = String.valueOf(paramMap.get(FIELD_TYPE));
            String fieldValue = String.valueOf(paramMap.get(FIELD_VALUE));
            String operation = String.valueOf(paramMap.get(OPERATION));

            if (StringUtils.equalsIgnoreCase(fieldValue, "null")) {
                list.add(null);
            } else {
                if (LIKE_OPERATION.equals(operation)) {
                    list.add("%" + fieldValue + "%");
                } else if (BETWEEN_OPERATION.equals(operation)) {
                    String[] split = fieldValue.split("~");
                    list.add(String.valueOf(typeHandler(fieldType, split[0])));
                    list.add(String.valueOf(typeHandler(fieldType, split[1])));
                } else if (IN_OPERATION.equals(operation)) {
                    String[] split = fieldValue.split(",");
                    for (String s : split) {
                        list.add(String.valueOf(typeHandler(fieldType, s)));
                    }
                } else {
                    list.add(typeHandler(fieldType, fieldValue));
                }
            }
        }
        return list.toArray();
    }*/


}
