package net.wanji.common.framework.domain;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * @Description: 数据库数据源
 * @Author: xiaodong.zheng
 * @Date: 2020/12/15 15:34
 * @param
 * @return
**/
@Data
@ApiModel(value = "DataBase", description = "数据库")
public class Db extends TrackableEntity {
    @ApiModelProperty(value = "数据源名称")
    private String name;

    @ApiModelProperty(value = "数据源中文名称")
    private String nameCn;

    @ApiModelProperty(value = "数据源目录ID")
    private String catalogId;

    @ApiModelProperty(value = "数据源描述")
    private String description;

    @ApiModelProperty(value = "应用类型",example = "datasource,dataset")
    private String appType;

    @ApiModelProperty(value = "数据库类型", example = "mysql, oracle, sql server")
    private String dbType;

    @ApiModelProperty(value = "数据库ip")
    private String ip;

    @ApiModelProperty(value = "数据库端口")
    private String port;

    @ApiModelProperty(value = "数据库名称")
    private String dbName;

    @ApiModelProperty(value = "用户名")
    private String user;

    @ApiModelProperty(value = "密码")
    private String pwd;

    @ApiModelProperty(value = "Oracle数据库的模式")
    private String schemaName;
}
