package net.wanji.common.framework.domain;

import com.alibaba.fastjson.annotation.JSONField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

/**
 * 业务表模块操作日志实体类。
 *
 * @Author guoliang.dong@wanji.com
 * @Date 2021/12/22 17:30
 */
@Data
@ApiModel(description = "操作日志")
public class OperationLog extends TrackableEntity {
    @ApiModelProperty("操作对象中文名)")
    private String resName;

    @ApiModelProperty("操作对象（类名）")
    private String resType;

    @ApiModelProperty("操作类型（方法)")
    private String operationType;

    @ApiModelProperty("操作人")
    private String operationUser;

    @ApiModelProperty("数据库id(有则记录)")
    private String dbId;

    @ApiModelProperty("操作描述信息(请求参数，json|多个参数都好分割)")
    private String des;

    @ApiModelProperty("操作状态")
    private String status;

    @ApiModelProperty("操作时长（结束-开始，单位毫秒）")
    private Long operationTime;

    @ApiModelProperty("开始时间")
    @JSONField(format = "yyyy-MM-dd HH:mm:ss")
    private Date startTime;

    @ApiModelProperty("结束时间")
    @JSONField(format = "yyyy-MM-dd HH:mm:ss")
    private Date endTime;

    @ApiModelProperty(value = "登录ip")
    private String operationIp;

    @ApiModelProperty(value = "请求参数详情")
    private String clientParam;

    @ApiModelProperty(value = "登录操作系统")
    private String operationOS;

    @ApiModelProperty(value = "登录浏览器")
    private String operationBrowser;


}
