package net.wanji.common.framework.dubbointerface;

import net.wanji.common.framework.exception.DubboProviderException;
import net.wanji.common.framework.rest.JsonViewObject;
import org.elasticsearch.index.query.BoolQueryBuilder;

import java.util.Map;

// log 抽象接口，  所有 log 的接口都需要继承
public interface BaseLogInterface {

    Boolean makeQueryBuilder(Map<String, Object> queryCondition, BoolQueryBuilder qb) throws Exception;

    /**
     * 查询接口
     *
     * @param params
     * @return
     */
    JsonViewObject logQuery(Map<String, Object> params) throws DubboProviderException;

    /**
     * 查询接口
     *
     * @param params
     * @return
     */
    JsonViewObject queryData(Map<String, Object> params) throws DubboProviderException;

    /**
     * 保存日志
     *
     * @param logData
     * @return
     */
    boolean saveServiceLog(String indexName, String typeName, Map<String, Object> logData) throws DubboProviderException;
}
