package net.wanji.common.framework.event;

import org.springframework.context.ApplicationEvent;

/**
 * @Description: spring 事件驱动模型，定义事件源
 * @Author wanji
 * @Date 2020/3/22 16:49
 */
public abstract class BaseEvent<T> extends ApplicationEvent {

    private static final long serialVersionUID = 895628808370649881L;

    protected T eventData;

    public BaseEvent(Object source, T eventData) {
        super(source);
        this.eventData = eventData;
    }

    public BaseEvent(T eventData) {
        super(eventData);
    }

    public T getEventData() {
        return eventData;
    }

    public void setEventData(T eventData) {
        this.eventData = eventData;
    }
}
