package net.wanji.common.framework.rest;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

import javax.ws.rs.core.MediaType;
import java.util.Map;

/**
 * @author wanji
 */
@Api(value = "log服务基础接口", description = "log服务基础接口")
public interface LogAbstractRestServer {

    @ApiOperation(value = "查询所有消息记录-Todo各种条件", notes = "Todo各种条件",
            response = JsonViewObject.class, produces = MediaType.APPLICATION_JSON, consumes = MediaType.APPLICATION_JSON)
    @PostMapping(value = "/queryLog", produces = MediaType.APPLICATION_JSON, consumes = MediaType.APPLICATION_JSON)
    JsonViewObject queryLog(@ApiParam(value = "查询条件", required = true,
            example = "{\"type\":\"job\",\"pageSize\":\"10\",\"pageNum\":\"1\",\"name\":\"张三\",\"startTime\":\"2018-10-10 11:12:00\",\"endTime\":\"2018-10-17 11:12:00\"}")
                            @RequestBody Map<String, Object> params);

    @ApiOperation(value = "查询所有消息记录-Todo各种条件", notes = "Todo各种条件",
            response = JsonViewObject.class, produces = MediaType.APPLICATION_JSON, consumes = MediaType.APPLICATION_JSON)
    @PostMapping(value = "/queryData", produces = MediaType.APPLICATION_JSON, consumes = MediaType.APPLICATION_JSON)
    JsonViewObject queryData(@ApiParam(value = "查询条件", required = true,
            example = "{\"type\":\"job\",\"pageSize\":\"10\",\"pageNum\":\"1\",\"name\":\"张三\",\"startTime\":\"2018-10-10 11:12:00\",\"endTime\":\"2018-10-17 11:12:00\"}")
                             @RequestBody Map<String, Object> params);
}
