package net.wanji.common.framework.rest;

import net.wanji.common.framework.domain.TrackableEntity;

import javax.validation.groups.Default;

/**
 * @Description: restful参数校验通用定义
 * @Author wanji
 * @Date 2020/8/26 13:10
 */
public class ValidationGroups {

    /**
     * @Description: 通用保存接口校验组，继承Default，否则每个属性都得加上分组属性
     *
     * @see AbstractRestServer#save
     * @Author wanji
     * @Date 2020/8/26 13:27
     **/
    public interface Create extends Default {}

    /**
     * @Description: 通用更新接口校验组，继承Default，否则每个属性都得加上分组属性
     *
     * @see AbstractRestServer#update
     * @Author wanji
     * @Date 2020/8/26 13:27
     **/
    public interface Update extends Default {}

    /**
     * @Description: 通用查询接口校验组，继承Default，否则每个属性都得加上分组属性
     *
     * @see AbstractRestServer#getByWhere(TrackableEntity)
     * @Author wanji
     * @Date 2020/8/26 13:27
     **/
    public interface Query extends Default {}
}
