package net.wanji.common.framework.rest.impl;

import net.wanji.common.framework.dubbointerface.BaseLogInterface;
import net.wanji.common.framework.rest.JsonViewObject;
import net.wanji.common.framework.rest.LogAbstractRestServer;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.RequestBody;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.core.Context;
import java.util.Map;

import static net.wanji.common.framework.Constants.LogType.OPERATION_LOG;

@Slf4j
public abstract class LogAbstractRestServerImpl implements LogAbstractRestServer {

    @Context
    protected HttpServletResponse response;

    @Context
    protected HttpServletRequest request;

    public abstract BaseLogInterface getBaseLogInterface();

    @Override
    public JsonViewObject queryLog(@RequestBody Map<String, Object> params) {
        JsonViewObject jsonView = JsonViewObject.newInstance();
        try {
            jsonView = this.getBaseLogInterface().logQuery(params);
        } catch (Exception e) {
            jsonView.fail(e.getMessage());
            log.error("queryLog error", e);
        }
        return jsonView;
    }

    @Override
    public JsonViewObject queryData(@RequestBody Map<String, Object> params) {
        JsonViewObject jsonView = JsonViewObject.newInstance();
        try {
            jsonView = this.getBaseLogInterface().queryData(params);
        } catch (Exception e) {
            jsonView.fail(e.getMessage());
            log.error("queryData error", e);
        }
        return jsonView;
    }



}
