package net.wanji.common.framework.spring;

import org.springframework.context.ApplicationContext;

/**
 * @author wanji
 */
public class ServiceBeanContext {

    private static volatile ApplicationContext ctx = null;


    private ServiceBeanContext() {
    }

    public static void loadContext(ApplicationContext context) {
        ctx = context;
    }

    public static ApplicationContext getContext() {
        return ctx;
    }

    public static <T> T getBean(String name) {
        return (T) ctx.getBean(name);
    }

    public static <T> T getBean(Class<T> clazz) {
        return ctx.getBean(clazz);
    }
}
