package net.wanji.common.utils.tool;

import java.math.BigInteger;
import java.util.Stack;

/**
 * @author hfx
 * @date 2023/1/16 15:45
 * @desc ConvertBaseUtils
 */
public class ConvertBaseUtils {

    private static final String TARGET_STR = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    private static final char[] chs = TARGET_STR.toCharArray();
    private static final BigInteger INTEGER0 = new BigInteger("0");
    private static final Integer SHIFT = 5;
    private static final Integer RADIX32 = 32;

    /**
     * 基数转换32进制，不足五位，补齐五位字符
     * @param number
     * @return
     */
    public static String numToRadix32(long number) {

        String buf = numToRadix(number +"", RADIX32);
        if(buf.length() < SHIFT) {
            int num = SHIFT - buf.length();
            for(int i = 0; i < num; i++) {
                buf = "0" + buf;
            }
        }
        return buf;
    }

    /**
     * 10进制转任意进制
     * @param number
     * @param radix
     * @return
     */
    public static String numToRadix(String number, int radix) {

        if (radix < 0 || radix > TARGET_STR.length()) {
            radix = TARGET_STR.length();
        }

        BigInteger bigNumber = new BigInteger(number);
        BigInteger bigRadix = new BigInteger(radix + "");

        Stack<Character> stack = new Stack<>();
        StringBuilder result = new StringBuilder(0);
        while (!bigNumber.equals(INTEGER0)) {
            stack.add(chs[bigNumber.remainder(bigRadix).intValue()]);
            bigNumber = bigNumber.divide(bigRadix);
        }
        for (; !stack.isEmpty(); ) {
            result.append(stack.pop());
        }
        return result.length() == 0 ? "0" : result.toString();
    }

}
