package net.wanji.common.utils.tool;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import org.dom4j.Attribute;
import org.dom4j.Element;

import java.util.ArrayList;
import java.util.List;

import static org.apache.commons.lang3.StringUtils.isEmpty;

/**
 * @ClassName JsonUtil
 * @Description
 * @Author wanji
 * @Date 2020/6/3 11:15
 * @Version 1.0
 */
public class JsonUtil {
    /**
     * xml转json
     *
     * @param element
     * @param json
     */
    public static void dom4j2Json(Element element, JSONObject json) {
        //如果是属性
        for (Object o : element.attributes()) {
            Attribute attr = (Attribute) o;
            if (!isEmpty(attr.getValue())) {
                json.put("@" + attr.getName(), attr.getValue());
            }
        }
        List<Element> chdEl = element.elements();
        if (chdEl.isEmpty() && !isEmpty(element.getText())) {//如果没有子元素,只有一个值
            json.put(element.getName(), element.getText());
        }

        for (Element e : chdEl) {//有子元素
            if (!e.elements().isEmpty()) {//子元素也有子元素
                JSONObject chdjson = new JSONObject();
                dom4j2Json(e, chdjson);
                Object o = json.get(e.getName());
                if (o != null) {
                    JSONArray jsona = null;
                    if (o instanceof JSONObject) {//如果此元素已存在,则转为jsonArray
                        JSONObject jsono = (JSONObject) o;
                        json.remove(e.getName());
                        jsona = new JSONArray();
                        jsona.add(jsono);
                        jsona.add(chdjson);
                    }
                    if (o instanceof JSONArray) {
                        jsona = (JSONArray) o;
                        jsona.add(chdjson);
                    }
                    json.put(e.getName(), jsona);
                } else {
                    if (!chdjson.isEmpty()) {
                        json.put(e.getName(), chdjson);
                    }
                }
            } else {//子元素没有子元素
                for (Object o : element.attributes()) {
                    Attribute attr = (Attribute) o;
                    if (!isEmpty(attr.getValue())) {
                        json.put("@" + attr.getName(), attr.getValue());
                    }
                }
                if (!e.getText().isEmpty()) {
                    Object o = json.get(e.getName());
                    if (o != null) {
                        List list = null;
                        if (o instanceof String) {//如果此元素已存在,则转为jsonArray
                            list = new ArrayList<>();
                            list.add(o);
                        }
                        if (o instanceof ArrayList) {
                            list = (List) o;
                        }
                        String name = e.getName();
                        String text = e.getText();
                        list.add(text);
                        json.put(name, list);
                    } else {
                        json.put(e.getName(), e.getText());
                    }
                }
            }
        }
    }

//    public static void main(String[] args) {
//        Map headerMap = new HashMap() {{
//            put("Content-Type", "text/xml; charset=utf-8");
//        }};
//        String targetUrl = "http://www.webxml.com.cn/WebServices/WeatherWebService.asmx?wsdl";
//        String targetNamespace = "http://WebXml.com.cn/";
//        String funName = "getSupportCity";
//        Map bodyMap = new HashMap() {{
//            put("byProvinceName", "河北");
//        }};
//        String soapXml = SoapUtils.buildSoapXml(targetNamespace, funName, bodyMap);
//        String xml = null;
//        try {
//            xml = WebServiceUtils.doPostSoap1_1(targetUrl, soapXml, headerMap);
//            System.out.println(xml);
//        } catch (DubboProviderException e) {
//            e.printStackTrace();
//        }
//        JSONObject jsonObject = new JSONObject();
//        Document doc = null;
//        try {
//            doc = DocumentHelper.parseText(xml);
//        } catch (DocumentException e) {
//            e.printStackTrace();
//        }
//        JsonUtil.dom4j2Json(doc.getRootElement(), jsonObject);
//        Object result = jsonObject.get("Body");
//        System.out.println(String.valueOf(result));
//    }
}
