package net.wanji.common.utils.tool;

import net.wanji.common.tool.wsdltool.DoSoapTool;
import org.dom4j.DocumentException;
import org.json.JSONObject;
import org.json.XML;

import java.io.IOException;

/**
 * @ClassName JsonXmlUtils
 * @Description
 * @Author wanji
 * @Date 2020/7/28 10:34
 * @Version 1.0
 */
public class JsonXmlUtils {


    private static JSONObject xmlToJson(String xml, boolean keepStrings) {
        if (StringUtils.isNotBlank(xml)) {
            JSONObject jsonObject = XML.toJSONObject(xml, keepStrings);
            StringBuilder stringBuilder = new StringBuilder();
            JSONObject json = new JSONObject();
            String envelope = null;
            for (String s : jsonObject.keySet()) {
                if (StringUtils.containsIgnoreCase(s, "Envelope")) {
                    envelope = s;
                    break;
                }
            }
            stringBuilder.append(envelope);
            JSONObject envelopeValue = jsonObject.getJSONObject(envelope);
            // 组装重构生成的json
            packageJson(stringBuilder, envelopeValue);
            json.put(stringBuilder.toString(), envelopeValue);
            return json;
        }
        return null;
    }

    public static String xmlToJsonString(String xml) {
        return xmlToJsonString(xml, true);
    }

    public static String soapXmlToJsonString(String xml) {
        return xmlToJsonString(xml, true);
    }


    public static String xmlToJsonString(String xml, boolean keepStrings) {
        if (StringUtils.isNotBlank(xml)) {
            JSONObject jsonObject = xmlToJson(xml, keepStrings);
            if (jsonObject != null) {
                return jsonObject.toString();
            }
        }
        return null;
    }

    public static String jsonToXml(Object json) {
        if (json != null) {
            String s = XML.toString(new JSONObject(json + ";"));
            return s.substring(0, s.lastIndexOf(":Envelope")) + ":Envelope>";
        }
        return null;
    }


    public static String jsonToSoapXml(Object json) {
        if (json != null) {
            String s = XML.toString(new JSONObject(json + ";"));
            return s.substring(0, s.lastIndexOf(":Envelope")) + ":Envelope>";
        }
        return null;
    }

    private static void packageJson(StringBuilder stringBuilder, JSONObject envelopeValue) {
        for (String s : envelopeValue.keySet()) {
            if (s.startsWith("xmlns:")) {
                stringBuilder.append(" ").append(s).append("=").append("\"").append(envelopeValue.getString(s)).append("\"");
                envelopeValue.remove(s);
                if (envelopeValue.length() > 0) {
                    packageJson(stringBuilder, envelopeValue);
                }
                return;
            }
        }
    }

    public static void main(String[] args) throws DocumentException, IOException {
        String xml = "<soap:Envelope xmlns:soap=\"http://www.w3.org/2003/05/soap-envelope\" xmlns:web=\"http://WebXml.com.cn/\">\n" +
                "   <soap:Header/>\n" +
                "   <soap:Body>\n" +
                "      <web:getSupportCity>\n" +
                "         <!--Optional:-->\n" +
                "         <web:byProvinceName>河北</web:byProvinceName>\n" +
                "      </web:getSupportCity>\n" +
                "   </soap:Body>\n" +
                "</soap:Envelope>";
        String s2 = DoSoapTool.doPostSoap("http://www.webxml.com.cn/WebServices/WeatherWebService.asmx?wsdl", xml);
        System.out.println(s2);
    }
}
